class A {
    constructor(readonly a: number) { }
}
class B {
    constructor(private readonly _b: string) { }
}
function f(n: number): A; // Overloading (spec.) // Evite : 'const r2: A = <A>f(0);'
function f(s: string): B; // Overloading (spec.)
function f(x: number | string): A | B { // Implementation
    return typeof x === "number" ? new A(x) : new B(x);
}
// const r1: B = f(0); // Compilation error...
const r2: A = f(0); // OK

// Le type 'X' est défini comme conditionnel, il est générique paramétré par 'T' compatible à 'number' ou 'string' :
type X<T extends number | string> = T extends number ? A : B;
// La fonction 'g' est générique paramétré par 'T'compatible à 'number' ou 'string' :
function g<T extends number | string>(x: T): X<T> {
    return typeof x === "number" ? new A(x) as X<T> : new B(x) as X<T>; // Horrible mais bon...
}
// const a_: B = f(0); // Compilation error...
const a_: A = g(0); // OK

type Y<T extends { a: unknown }> = A["a"];
const y: Y<A> = 0; // Le type de 'y' est 'number'...
// const z: Y<B> = true; // Compilation error...